
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Grouping

Public Class Form1
    Inherits System.Windows.Forms.Form
    Private gridGroupingControl1 As Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl

    Private components As System.ComponentModel.Container = Nothing


    Public Sub New()

        InitializeComponent()
    End Sub 'New

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose

#Region "Windows Form Designer generated code"

    '/ <summary>
    '/ Required method for Designer support - do not modify
    '/ the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Me.gridGroupingControl1 = New Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl()
        CType(Me.gridGroupingControl1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        ' 
        ' gridGroupingControl1
        ' 
        Me.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window
        Me.gridGroupingControl1.Location = New System.Drawing.Point(48, 32)
        Me.gridGroupingControl1.Name = "gridGroupingControl1"
        Me.gridGroupingControl1.Size = New System.Drawing.Size(384, 360)
        Me.gridGroupingControl1.TabIndex = 1
        Me.gridGroupingControl1.TableDescriptor.Name = "Default"
        Me.gridGroupingControl1.Text = "gridGroupingControl1"
        ' 
        ' Form1
        ' 
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(480, 422)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.gridGroupingControl1})
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.gridGroupingControl1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
    End Sub 'InitializeComponent 
#End Region

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'set gridGroupingControl1 properties
        Me.gridGroupingControl1.DataSource = GetADataTable()
        Me.gridGroupingControl1.ShowGroupDropArea = True

        'color "Col2" so it is easier to see
        Me.gridGroupingControl1.TableDescriptor.Columns("Col2").Appearance.AnyRecordFieldCell.BackColor = Color.LightGoldenrodYellow

        'group "Col2" using a custom categorizer and Comparer
        Dim cd As New Syncfusion.Grouping.SortColumnDescriptor("Col2")
        cd.Categorizer = New CustomCategorizer()
        cd.Comparer = New CustomComparer()
        Me.gridGroupingControl1.TableDescriptor.GroupedColumns.Add(cd)

        'subcribe to event to display custom group caption
        AddHandler Me.gridGroupingControl1.QueryCellStyleInfo, AddressOf gridGroupingControl1_QueryCellStyleInfo
    End Sub 'Form1_Load

    'create the datasource
    Private Function GetADataTable() As DataTable

        Dim dt As New DataTable("MyTable")

        Dim nCols As Integer = 4
        Dim nRows As Integer = 50

        Dim i As Integer
        For i = 0 To nCols - 1
            dt.Columns.Add(New DataColumn(String.Format("Col{0}", i)))
        Next i
        Dim r As New Random()

        i = 0
        While i < nRows
            Dim dr As DataRow = dt.NewRow()
            Dim j As Integer
            For j = 0 To nCols - 1
                dr(j) = r.Next(100).ToString()
            Next j
            dt.Rows.Add(dr)
            i += 1
        End While

        Return dt
    End Function 'GetADataTable

    'handle QueryCellStyleInfo to display custom text to match the custom categorizer
    Private Sub gridGroupingControl1_QueryCellStyleInfo(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs)
        If Not (e.TableCellIdentity.GroupedColumn Is Nothing) AndAlso Not (e.TableCellIdentity.DisplayElement.ParentGroup Is Nothing) AndAlso TypeOf e.TableCellIdentity.DisplayElement.ParentGroup.Category Is Integer Then
            If TypeOf e.TableCellIdentity.DisplayElement Is CaptionRow AndAlso e.TableCellIdentity.GroupedColumn.Name = "Col2" Then
                Dim cat As Integer = Fix(e.TableCellIdentity.DisplayElement.ParentGroup.Category)
                Dim ret As String = ""
                Select Case cat
                    Case 1
                        ret = " < 10"
                    Case 2
                        ret = "10 - 19"
                    Case 3
                        ret = "20 - 29"
                    Case 4
                        ret = "30 - 39"
                    Case 5
                        ret = " >= 40"
                End Select
                e.Style.CellValue = String.Format("{0}: {1} Items.", ret, e.TableCellIdentity.DisplayElement.ParentGroup.GetChildCount())
            End If
        End If
    End Sub 'gridGroupingControl1_QueryCellStyleInfo
End Class 'Form1

#Region "Custom Comparer class"

'make sure the string integers are sorted as integers instead of strings
Public Class CustomComparer
    Implements IComparer
#Region "IComparer Members"

    Public Function [Compare](ByVal x As Object, ByVal y As Object) As Integer Implements IComparer.Compare
        If x Is Nothing Then
            Return -1
        ElseIf y Is Nothing Then
            Return 100
        Else
            Dim i As Integer = Integer.Parse(x.ToString())
            Dim j As Integer = Integer.Parse(y.ToString())
            Return i - j
        End If
    End Function 'Compare

#End Region
End Class 'CustomComparer 

#End Region

#Region "Custom Categorizer class"
'defines custom categorizer
Public Class CustomCategorizer
    Implements Syncfusion.Grouping.IGroupByColumnCategorizer


    'defines a group and returns a group category object (here returns 1 through 5)
    Public Shared Function GetCategory(ByVal i As Integer) As Integer
        Dim ret As Integer = 0
        If i < 10 Then
            ret = 1
        ElseIf i >= 10 AndAlso i < 20 Then
            ret = 2
        ElseIf i >= 20 AndAlso i < 30 Then
            ret = 3
        ElseIf i >= 30 AndAlso i < 40 Then
            ret = 4
        Else
            ret = 5
        End If
        Return ret
    End Function 'GetCategory

#Region "IGroupByColumnCategorizer Members"

    Public Function GetGroupByCategoryKey(ByVal column As SortColumnDescriptor, ByVal isForeignKey As Boolean, ByVal record As Record) As Object Implements IGroupByColumnCategorizer.GetGroupByCategoryKey
        Return GetCategory(Integer.Parse(record.GetValue(column).ToString()))
    End Function 'GetGroupByCategoryKey

    Public Function CompareCategoryKey(ByVal column As SortColumnDescriptor, ByVal isForeignKey As Boolean, ByVal category As Object, ByVal record As Record) As Integer Implements IGroupByColumnCategorizer.CompareCategoryKey
        Return GetCategory(Integer.Parse(record.GetValue(column).ToString())) - Fix(category)
    End Function 'CompareCategoryKey

#End Region

End Class 'CustomCategorizer
#End Region

 